unit Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Preview, Buttons, Paper, Gauges, Printers, jpeg;

Type
  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Memo1: TMemo;
    CheckBox1: TCheckBox;
    Image1: TImage;
    Button3: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure Memo1Exit(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { Private declarations }
    Procedure Draw;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  Preview1 : TPreview;

implementation


{$R *.DFM}
Procedure TForm1.Draw;
Var
  RGN  : HRGN;
  RGN2 : HRGN;
  RGN3 : HRGN;
  I    : Integer;
Begin
  With Preview1.Paper Do
    Begin
      Clear;
      SetPage( 1 );
      SetBrush( exLinear, clRed, clBlack, Nil, 0 );
      RoundRect( 625, 100, 1375, 250, 50, 50 );//OK
      SetBrush( exLinear, clBlack, clRed, Nil, 0 );
      SetFont( 'Times New Roman', 26, [fsBold], clBlack );
      TextRect( Rect(625, 115, 1375, 210), 630, 105, 'TPreview Sample' );
      SetBrush( exClear, 0, 0, Nil, 0 );
      SetFont( 'Times New Roman', 18, [fsBold, fsItalic], clBlack );
      TextOut( 107, 293, 'Delphi 5 component designed by' );
      SetBrush( exLinear, clYellow, clLime, Nil, 0 );
      TextOut( 100, 300, 'Delphi 5 component designed by' );
      SetFont( 'Courier New', 20, [fsBold], clBlack );
      SetBrush( exLinearDouble, clWhite, clNavy, Nil, 90 );
      TextOut( 1100, 298, 'Rustam' );
      TextOut( 1400, 298, 'Kafarov' );
      SetBrush( exClear, clBlue, clAqua, Nil, 90 );
      SetFont( 'Arial', 16, [fsItalic], clBlack );
      TextOut( 100, 400, 'e-mail: ');
      SetFont( 'Arial', 16, [fsUnderLine], clBlue );
      TextOut( 300, 400, 'rustamkafarov@hotmail.com' );
      SetBrush( exSolid, clGreen, clAqua, Nil, 0 );
      Rectangle( 100, 500, 600, 600 );
      Pie( 1100, 500, 1600, 600, 1600, 100, 1800, 700 );
      SetBrush( exSquare, clYellow, clBlack, Nil, 10 );
      Polygon( [Point(100,700), Point(500,800), Point(400,800), Point(250,900), Point(100,700)] );
      Ellipse( 1100, 700, 1600, 800 );
      StretchDraw( Rect(200, 1000, 600, 1400), Image1.Picture.Graphic );

      SetBrush( exClear, clRed, clAqua, Nil, 0 );
      SetFont( 'Arial', 16, [], clBlack );
      TextOut( 650, 530, '- rectangle' );
      TextOut( 1650, 530, '- pie' );
      TextOut( 650, 730, '- polygon' );
      TextOut( 1650, 730, '- ellipse' );
      TextOut( 650, 1230, '- picture' );
      TextOut( 1370, 1230, '- region' );
      For I := 0 To Memo1.Lines.Count-1 Do
        Begin
          TextOut( 400, 1700 + (I*100), Memo1.Lines.Strings[I] );
        End;
      SetBrush( exRadial, clNavy, clWhite, Nil, 0 );
      RGN := CreateRectRGN( 1300, 1100, 1600, 1400 );
      RGN2 := CreateEllipticRGN( 1300, 1100, 1600, 1400 );
      RGN3 := CreateEllipticRGN( 1100, 900, 1800, 1600 );
      CombineRGN( RGN, RGN2, RGN3, RGN_XOR );
      DrawRegion( RGN );
      DeleteObject( RGN3 );
      DeleteObject( RGN2 );
      DeleteObject( RGN );
    End;
End;


procedure TForm1.Button1Click(Sender: TObject);
begin
  Preview1.Preview;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  Preview1.Print;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  Preview1 := TPreview.Create( Self );
  Preview1.Paper.Units := unTenthMillimeters;
  Draw;
end;

procedure TForm1.CheckBox1Click(Sender: TObject);
begin
  Memo1.ReadOnly := Not CheckBox1.Checked;
end;

procedure TForm1.Memo1Exit(Sender: TObject);
begin
  Draw;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  Preview1.Paper.CompressionQuality := 100;
  Preview1.Paper.ExportPageToFile( 'Page1.bmp', 1, ifBitmap );
  Preview1.Paper.ExportPageToFile( 'Page1.jpg', 1, ifJPEG );
  Preview1.Paper.ExportPageToFile( 'Page1.emf', 1, ifMetaFile );
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  Preview1.Free;
end;

end.

