unit PreviewForm;

interface

uses
  Windows, Graphics, ExtCtrls, Buttons, Classes, Controls, Forms,
  ExScrollBar, ComCtrls, StdCtrls, SysUtils, Preview, Paper, DIB_Image, Printers,
  Menus, Dialogs;

Type
  TfmPreview = class(TCustomPreviewForm)
    LeftPanel: TPanel;
    BottomPanel: TPanel;
    StatusBar1: TStatusBar;
    Edit1: TEdit;
    PanelRight: TPanel;
    PanelBottom: TPanel;
    Panel1: TPanel;
    Panel2: TPanel;
    Bevel1: TBevel;
    Bevel2: TBevel;
    BasePanel: TPanel;
    EmptyLeftPanel: TPanel;
    TopPanel: TPanel;
    Bevel5: TBevel;
    ToolsPanel: TPanel;
    Bevel3: TBevel;
    PanelClose: TPanel;
    sbClose: TSpeedButton;
    sbZoomIn: TSpeedButton;
    sbZoomOut: TSpeedButton;
    PanelZoom: TPanel;
    cbScale: TEdit;
    Bevel4: TBevel;
    PanelPage: TPanel;
    edPageNum: TEdit;
    udPage: TUpDown;
    sbFirst: TSpeedButton;
    sbPrev: TSpeedButton;
    sbNext: TSpeedButton;
    sbLast: TSpeedButton;
    PanelprintSetup: TPanel;
    sb_PageSetup: TSpeedButton;
    PanelPrint: TPanel;
    sb_Print: TSpeedButton;
    PanelOpen: TPanel;
    sb_Open: TSpeedButton;
    PanelSave: TPanel;
    sb_Save: TSpeedButton;
    PanelHelp: TPanel;
    sb_Help: TSpeedButton;
    PanelAbout: TPanel;
    sb_About: TSpeedButton;
    sbDropDown: TSpeedButton;
    Bevel6: TBevel;
    Bevel7: TBevel;
    sbLanguage: TSpeedButton;
    menuLanguage: TPopupMenu;
    menuEnglish: TMenuItem;
    menuRussian: TMenuItem;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    PrintDialog1: TPrintDialog;
    PopupMenuZoom: TPopupMenu;
    menu200: TMenuItem;
    menu150: TMenuItem;
    menu100: TMenuItem;
    menu75: TMenuItem;
    menu50: TMenuItem;
    menu25: TMenuItem;
    menuFitWidth: TMenuItem;
    menuFitHeight: TMenuItem;
    menuWholePage: TMenuItem;
    n1: TMenuItem;
    procedure FormActivate(Sender: TObject);
    procedure sbZoomInClick(Sender: TObject);
    procedure sbCloseClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure sbZoomOutClick(Sender: TObject);
    procedure cbScaleKeyPress(Sender: TObject; var Key: Char);
    procedure edPageNumEnter(Sender: TObject);
    procedure edPageNumKeyPress(Sender: TObject; var Key: Char);
    procedure udPageChangingEx(Sender: TObject; var AllowChange: Boolean;
      NewValue: Smallint; Direction: TUpDownDirection);
    procedure sbFirstClick(Sender: TObject);
    procedure sbPrevClick(Sender: TObject);
    procedure sbNextClick(Sender: TObject);
    procedure sbLastClick(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormPaint(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure btDropDownClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure sbLanguageClick(Sender: TObject);
    procedure menuEnglishClick(Sender: TObject);
    procedure sb_PrintClick(Sender: TObject);
    procedure sb_OpenClick(Sender: TObject);
    procedure sb_SaveClick(Sender: TObject);
    procedure OpenDialog1Show(Sender: TObject);
    procedure sb_HelpClick(Sender: TObject);
    procedure FormMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure FormMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure menu200Click(Sender: TObject);
    procedure sb_PageSetupClick(Sender: TObject);
    procedure sb_AboutClick(Sender: TObject);
  private
    { Private declarations }
    DrawIndex     : Integer;
    BackUpScale   : String;
    BackUpPage    : String;
    ScrollBarVert : TExScrollbar;
    ScrollBarHorz : TExScrollbar;
    PaperDX       : Integer;
    PaperDY       : Integer;
    ResultImage   : TDIB;
    CanKeyPress   : Boolean;
    FirstTime     : Boolean;
    DrawProgress  : TProgressBar;
    Lang          : TLanguage;
    CanDragging   : Boolean;
    Dragging      : Boolean;
    DragX, PosX   : Integer;
    DragY, PosY   : Integer;
    Procedure OnChangeScale( Sender : TObject );
    Procedure OnChangePage( Sender : TObject );
    Procedure OnVertScroll(Sender: TObject; ScrollCode: TScrollCode; var ScrollPos: Integer);
    Procedure OnHorzScroll(Sender: TObject; ScrollCode: TScrollCode; var ScrollPos: Integer);
    Procedure DrawShadows;
    Procedure DrawIdentions( Zoom : Real; Scale : TScale );
    Procedure DrawItems( Sender : TObject; ItemType : Word; Index : Integer );
    Procedure SetLanguage;
  public
    { Public declarations }
  published
    { Published declarations }
  end;

Const
  SmallChange_Range = 40;
  LargeChange_Range = 10;
  SmallChange_Value = 20;
  LargeChange_Value = 200;
  ShadowOffsetX = 2;

  ShadowOffsetY = 2;

  ScalesValues   : Array [TLanguage] Of String  =
  ( '"200%","150%","100%","75%","50%","25%","fit to width","fit to height","whole page"',
    '"200%","150%","100%","75%","50%","25%"," "," ",""' );
  ZoomInHint     : Array [TLanguage] Of String  = ('Zoom in', '');
  ZoomOutHint    : Array [TLanguage] Of String  = ('Zoom out', '');
  ScaleValue     : Array [TLanguage] Of String  = ('Scale', '');
  PageValue      : Array [TLanguage] Of String  = ('Page#', '. ');
  FirstHint      : Array [TLanguage] Of String  = ('First', '');
  PrevHint       : Array [TLanguage] Of String  = ('Previous', '');
  NextHint       : Array [TLanguage] Of String  = ('Next', '');
  LastHint       : Array [TLanguage] Of String  = ('Last', '');
  PageSetupHint  : Array [TLanguage] Of String  = ('Page setup', ' ');
  PrintHint      : Array [TLanguage] Of String  = ('Print', '');
  LoadHint       : Array [TLanguage] Of String  = ('Load from file', '  ');
  SaveHint       : Array [TLanguage] Of String  = ('Save to file', '  ');
  HelpHint       : Array [TLanguage] Of String  = ('Help', '');
  AboutHint      : Array [TLanguage] Of String  = ('About component "TPreview"', '  "TPreview"');
  CloseHint      : Array [TLanguage] Of String  = ('Close', '');
  Panel1Value    : Array [TLanguage] Of String  = (' Total pages - ', '   - ');
  Panel2Value    : Array [TLanguage] Of String  = ('Current page - ', ' - ');
  Panel3Value    : Array [TLanguage] Of String  = ('Scale - ', ' - ');
  Panel4Value    : Array [TLanguage] Of String  = ('Eng', '');
  EnglishValue   : Array [TLanguage] Of String  = ('English         ', '');
  RussianValue   : Array [TLanguage] Of String  = ('Russian', '');
  ReadQuestion   : Array [TLanguage] Of String  = ('Clear existing image?', '  ?');
  WriteQuestion  : Array [TLanguage] Of String  = ('Clear existing file?', '  ?');
  ReadTitle      : Array [TLanguage] Of String  = ('Opening mode', ' ');
  WriteTitle     : Array [TLanguage] Of String  = ('Saving mode', ' ');
  LangHint       : Array [TLanguage] Of String  = ('Language select', ' ');
  PrintValue     : Array [TLanguage] Of String  = ('Do you want print image?', ' ?');
  PrintTitle     : Array [TLanguage] Of String  = ('Printing', '');
  
Var
  fmPreview : TfmPreview;

Const
  DefaultFileName = 'untitled';
  CursorDrag = 25;


function HtmlHelpA( hwndCaller: HWND; pszFile: PAnsiChar; uCommand: UINT;
                    dwData: DWORD ): HWND; stdcall;

implementation
Uses ScalesList, PrinterOptionsEd, ShellAPI;

const
  hhctrl = 'hhctrl.ocx';

function HtmlHelpA; external hhctrl Name 'HtmlHelpA';

{$R *.DFM}
{$R Cursor.res}

{ TPreviewForm }

Procedure TfmPreview.SetLanguage;
Begin
  Lang := _Preview.Language;
  Case Lang Of
  English : menuEnglish.Checked := True;
  Russian : menuRussian.Checked := True;
  End;{ Case }
  menuEnglish.Caption := EnglishValue[Lang];
  menuRussian.Caption := RussianValue[Lang];
  fmScalesList.ListBox1.Items.CommaText := ScalesValues[Lang];
  menu200.Caption := fmScalesList.ListBox1.Items.Strings[0];
  menu150.Caption := fmScalesList.ListBox1.Items.Strings[1];
  menu100.Caption := fmScalesList.ListBox1.Items.Strings[2];
  menu75.Caption := fmScalesList.ListBox1.Items.Strings[3];
  menu50.Caption := fmScalesList.ListBox1.Items.Strings[4];
  menu25.Caption := fmScalesList.ListBox1.Items.Strings[5];
  menuFitWidth.Caption := fmScalesList.ListBox1.Items.Strings[6];
  menuFitHeight.Caption := fmScalesList.ListBox1.Items.Strings[7];
  menuWholePage.Caption := fmScalesList.ListBox1.Items.Strings[8];
  sbZoomIn.Hint := ZoomInHint[Lang];
  sbZoomOut.Hint := ZoomOutHint[Lang];
  PanelZoom.Caption := ScaleValue[Lang];
  PanelPage.Caption := PageValue[Lang];
  sbFirst.Hint := FirstHint[Lang];
  sbPrev.Hint := PrevHint[Lang];
  sbNext.Hint := NextHint[Lang];
  sbLast.Hint := LastHint[Lang];
  sb_PageSetup.Hint := PageSetupHint[Lang];
  sb_Print.Hint := PrintHint[Lang];
  sb_Open.Hint := LoadHint[Lang];
  sb_Save.Hint := SaveHint[Lang];
  sb_Help.Hint := HelpHint[Lang];
  sb_About.Hint := AboutHint[Lang];
  sbClose.Hint := CloseHint[Lang];
  StatusBar1.Panels[0].Text := Panel1Value[Lang] + IntToStr( udPage.Max );
  StatusBar1.Panels[1].Text := Panel2Value[Lang] + IntToStr( (_Preview As TPreview).CurrentPage );
  StatusBar1.Panels[2].Text := Panel3Value[Lang] + IntToStr( (_Preview As TPreview).Scale ) + '%';
  StatusBar1.Panels[3].Text := Panel4Value[Lang];
  StatusBar1.Panels[3].Text := Panel4Value[Lang];
  sbLanguage.Hint := LangHint[Lang];
End;

Procedure TfmPreview.DrawShadows;
Begin
  ResultImage.Canvas.Pen.Width := 1;
  ResultImage.Canvas.Pen.Style := psSolid;
  ResultImage.Canvas.Pen.Color := clGray;
  ResultImage.Canvas.Brush.Style := bsSolid;
  ResultImage.Canvas.Brush.Color := clWhite;
  ResultImage.Canvas.Rectangle( 0, 0, ResultImage.Width, ResultImage.Height );
  ResultImage.Canvas.Pen.Style := psClear;
  ResultImage.Canvas.Brush.Color := clBlack;
  ResultImage.Canvas.Rectangle( ResultImage.Width - ShadowOffsetX, 0, ResultImage.Width, ResultImage.Height );
  ResultImage.Canvas.Rectangle( 0, ResultImage.Height - ShadowOffsetY, ResultImage.Width, ResultImage.Height );
End;

Procedure TfmPreview.DrawIdentions( Zoom : Real; Scale : TScale );
Var
  X1, Y1, X2, Y2  : Integer;
Begin
  If _Paper.Indentions.Visible
    Then Begin
           ResultImage.Canvas.Pen.Width := 1;
           ResultImage.Canvas.Pen.Style := psDashDot;
           ResultImage.Canvas.Pen.Color := clSilver;
           ResultImage.Canvas.Brush.Style := bsClear;
           X1 := Round( _Paper.Indentions.Left * _Paper.PixelsPerMM.X * Zoom * Scale/100 );
           Y1 := Round( _Paper.Indentions.Top * _Paper.PixelsPerMM.Y * Zoom * Scale/100 );
           X2 := Round( (_Paper.PrinterSetup.PaperWidth_MM - _Paper.Indentions.Right) * _Paper.PixelsPerMM.X * Zoom * Scale/100 );
           Y2 := Round( (_Paper.PrinterSetup.PaperHeight_MM - _Paper.Indentions.Bottom) * _Paper.PixelsPerMM.Y * Zoom * Scale/100 );
           ResultImage.Canvas.Rectangle( X1, Y1, X2, Y2 );
         End;
End;

Procedure TfmPreview.OnChangeScale( Sender : TObject );
Var
  Old        : Real;
  FrucScale  : Real;
  Inval_Rect : TRect;
  AWidth     : Integer;
  AHeight    : Integer;
  ReDraw     : Boolean;
  Zoom       : Real;
  Zoom1      : Real;
  Zoom2      : Real;
Begin
  Screen.Cursor := crHourGlass;
  ReDraw := False;
  cbScale.Text := IntToStr( _Preview.Scale ) + '%';
  StatusBar1.Panels[2].Text := Panel3Value[Lang] + IntToStr( _Preview.Scale ) + '%';
  BackUpScale := cbScale.Text;
  fmPreview.menu200.Checked := False;
  fmPreview.menu150.Checked := False;
  fmPreview.menu100.Checked := False;
  fmPreview.menu75.Checked := False;
  fmPreview.menu50.Checked := False;
  fmPreview.menu25.Checked := False;
  fmPreview.menuFitWidth.Checked := False;
  fmPreview.menuFitHeight.Checked := False;
  fmPreview.menuWholePage.Checked := False;
  Case _Preview.Scale Of
  200 : fmPreview.menu200.Checked := True;
  150 : fmPreview.menu150.Checked := True;
  100 : fmPreview.menu100.Checked := True;
  75  : fmPreview.menu75.Checked := True;
  50  : fmPreview.menu50.Checked := True;
  25  : fmPreview.menu25.Checked := True;
  End;{ case}

  FrucScale := _Preview.Scale / 100;
  AWidth := (WorkRect.Right-WorkRect.Left);
  AHeight := (WorkRect.Bottom-WorkRect.Top);

  If FrucScale*_Paper.Width > AWidth
    Then Begin
           Old := ScrollBarHorz.Position/(ScrollBarHorz.Max - AWidth);
           ScrollBarHorz.Max := Round( FrucScale * _Paper.Width );
           ScrollBarHorz.PageSize := AWidth;
           ScrollBarHorz.Position := Round(Old*(ScrollBarHorz.Max - AWidth));
           ScrollBarHorz.SmallChange := SmallChange_Value;
           ScrollBarHorz.LargeChange := LargeChange_Value;
           ScrollBarHorz.Enabled := True;
           PaperDX := WorkRect.Left - ScrollBarHorz.Position;
         End
    Else Begin
           PaperDX := WorkRect.Left + Round((AWidth - FrucScale*_Paper.Width)/2);
           ScrollBarHorz.Enabled := False;
           ReDraw := True;
         End;
  If FrucScale*_Paper.Height > AHeight
    Then Begin
           Old := ScrollBarVert.Position/(ScrollBarVert.Max - AHeight);
           ScrollBarVert.Max := Round( FrucScale * _Paper.Height );
           ScrollBarVert.PageSize := AHeight;
           ScrollBarVert.Position := Round(Old*(ScrollBarVert.Max - AHeight));
           ScrollBarVert.SmallChange := SmallChange_Value;
           ScrollBarVert.LargeChange := LargeChange_Value;
           ScrollBarVert.Enabled := True;
           PaperDY := WorkRect.Top - ScrollBarVert.Position;
         End
    Else Begin
           PaperDY := WorkRect.Top + Round((AHeight - FrucScale*_Paper.Height)/2);
           ScrollBarVert.Enabled := False;
           ReDraw := True;
         End;
  AWidth := Round( _Paper.Width * FrucScale );
  AHeight := Round( _Paper.Height * FrucScale );
  ResultImage.Width := AWidth;
  ResultImage.Height := AHeight;

  Zoom1 := _Paper.Width / Printer.PageWidth;
  Zoom2 := _Paper.Height / Printer.PageHeight;
  Zoom := (Zoom1 + Zoom2) / 2;
  CanKeyPress := False;
  DrawShadows;
  DrawIdentions( Zoom, _Preview.Scale );
  DrawProgress.Max := _Paper.GetItemsCountonPage( _Preview.CurrentPage );
  _Paper.DrawToCanvas( ResultImage.Canvas, Zoom, _Preview.Scale, _Preview.CurrentPage );
  Inval_Rect := WorkRect;
  InvalidateRect( Handle, @Inval_Rect, ReDraw );
  Screen.Cursor := crDefault;
End;

Procedure TfmPreview.OnChangePage( Sender : TObject );
Var
  Zoom, Zoom1, Zoom2 : Real;
  Inval_Rect : TRect;
Begin
  Screen.Cursor := crHourGlass;
  StatusBar1.Panels[1].Text := Panel2Value[Lang] + IntToStr( _Preview.CurrentPage );
  Zoom1 := _Paper.Width / Printer.PageWidth;
  Zoom2 := _Paper.Height / Printer.PageHeight;
  Zoom := (Zoom1 + Zoom2) / 2;
  CanKeyPress := False;
  DrawShadows;
  DrawIdentions( Zoom, _Preview.Scale );
  DrawProgress.Max := _Paper.GetItemsCountonPage( _Preview.CurrentPage );
  _Paper.DrawToCanvas( ResultImage.Canvas, Zoom, _Preview.Scale, _Preview.CurrentPage );
//  DrawProgress.Position := 0;
  Inval_Rect := WorkRect;
  InvalidateRect( Handle, @Inval_Rect, False );
  Screen.Cursor := crDefault;
End;

Procedure TfmPreview.OnVertScroll(Sender: TObject; ScrollCode: TScrollCode; var ScrollPos: Integer);
Var
  Inval_Rect : TRect;
Begin
  If PaperDY <> ScrollBarVert.Position
    Then Begin
           PaperDY := WorkRect.Top - ScrollBarVert.Position;
           Inval_Rect := WorkRect;
           InvalidateRect( Handle, @Inval_Rect, False );
         End;
End;

Procedure TfmPreview.OnHorzScroll(Sender: TObject; ScrollCode: TScrollCode; var ScrollPos: Integer);
Var
  Inval_Rect : TRect;
Begin
  If PaperDX <> ScrollBarHorz.Position
    Then Begin
           PaperDX := WorkRect.Left - ScrollBarHorz.Position;
           Inval_Rect := WorkRect;
           InvalidateRect( Handle, @Inval_Rect, False );
         End;
End;

Procedure TfmPreview.DrawItems( Sender : TObject; ItemType : Word; Index : Integer );
Begin
  DrawProgress.Position := Index;
  Inc( DrawIndex );
  If DrawIndex = _Paper.GetItemsCountOnPage( _Preview.CurrentPage )
    Then Begin
           DrawProgress.Position := 0;
           DrawIndex := 0;
         End;
End;

procedure TfmPreview.FormCreate(Sender: TObject);
Var
  R : TRect;
  B : TBitmap;
begin
  Screen.Cursors[CursorDrag] := LoadCursor(HInstance, 'crHandDrag');
  DrawIndex := 0;
  FirstTime := True;
  CanKeyPress := True;
  cbScale.MaxLength := Length( IntToStr(MAX_SCALE) ) + 1;
  Left := 0;
  Top := 0;
  Screen.Cursors[22] := LoadCursor(HInstance, 'crZoom');
  SystemParametersInfo( SPI_GETWORKAREA, 0, @R, SPIF_SENDCHANGE	);
  BoundsRect := R;
  WorkRect := Rect( LeftPanel.Width,
                    TopPanel.Height,
                    Width - PanelRight.Width - 1,
                    Height - PanelBottom.Height - 16 );
  Try
    fmScalesList := TfmScalesList.Create( Self );
  Except
    WriteToLog('Unit <PreviewForm>: Error in creating object "fmScalesList"');
  End;
  fmScalesList.Top := 25;
  fmScalesList.Left := 125;
  fmScalesList.Width := 84;
  Try
    DrawProgress := TProgressBar.Create( Self );
  Except
    WriteToLog('Unit <PreviewForm>: Error in creating object "DrawProgress"');
  End;
  DrawProgress.Parent := StatusBar1;
  DrawProgress.Left := 413;
  DrawProgress.Top := 3;
  DrawProgress.Width := ClientWidth - DrawProgress.Left - 2;
  DrawProgress.Height := 15;
  sbLanguage.Parent := StatusBar1;
  sbLanguage.Left := 394;
  sbLanguage.Top := 3;
  Try
    ScrollBarVert := TExScrollBar.Create( PanelRight );
  Except
    WriteToLog('Unit <PreviewForm>: Error in creating object "ScrollBarVert"');
  End;
  ScrollBarVert.Parent := PanelRight;
  ScrollBarVert.Kind := sbVertical;
  ScrollBarVert.TabStop := False;
  ScrollBarVert.Align := alLeft;
  ScrollBarVert.OnScroll := OnVertScroll;
  Try
    ScrollBarHorz := TExScrollBar.Create( PanelBottom );
  Except
    WriteToLog('Unit <PreviewForm>: Error in creating object "ScrollBarHorz"');
  End;
  ScrollBarHorz.Parent := PanelBottom;
  ScrollBarHorz.Kind := sbHorizontal;
  ScrollBarHorz.TabStop := False;
  ScrollBarHorz.Align := alClient;
  ScrollBarHorz.OnScroll := OnHorzScroll;
  Try
    ResultImage := TDIB.Create;
  Except
    WriteToLog('Unit <PreviewForm>: Error in creating object "ResultImage"');
    Exit;
  End;
  B := TBitmap.Create;
  Try
    B.PixelFormat := pf24bit;
    B.Width := 10;
    B.Height := 10;
    ResultImage.Assign( B );
  Finally
    B.Free;
  End;
end;

procedure TfmPreview.FormActivate(Sender: TObject);
begin
  If Not FirstTime
    Then Exit;
  CanDragging := True;
  Dragging:= False;
  FirstTime := False;
  CanKeyPress := True;
  With (Owner As TPreview) Do
    Begin
      If btAbout In Buttons
        Then PanelAbout.Visible := True
        Else PanelAbout.Visible := False;
      If btHelp In Buttons
        Then PanelHelp.Visible := True
        Else PanelHelp.Visible := False;
      If btSave In Buttons
        Then PanelSave.Visible := True
        Else PanelSave.Visible := False;
      If btOpen In Buttons
        Then PanelOpen.Visible := True
        Else PanelOpen.Visible := False;
      If btPrint In Buttons
        Then PanelPrint.Visible := True
        Else PanelPrint.Visible := False;
      If btPageSetup In Buttons
        Then PanelPrintSetup.Visible := True
        Else PanelPrintSetup.Visible := False;
      If btLanguage In Buttons
        Then sbLanguage.Visible := True
        Else sbLanguage.Visible := False;
    End;
  PrintDialog1.MaxPage := _Preview.MaxPage;
  PrintDialog1.MinPage := _Preview.MinPage;
  PrintDialog1.FromPage := _Preview.MinPage;  
  OpenDialog1.InitialDir := '.';
  SaveDialog1.Filename := DefaultFileName;
  SaveDialog1.InitialDir := '.';
  ScrollBarVert.Align := alClient;
  udPage.Height := 16;
  udPage.Width := 15;
  udPage.Left := 286;
  udPage.Top := 5;
  udPage.Min := _Preview.MinPage;
  udPage.Max := _Preview.MaxPage;
  udPage.Position := udPage.Min;
  ScrollBarVert.Position := 0;
  ScrollBarHorz.Position := 0;
  SetLanguage;
  cbScale.Text := IntToStr( _Preview.Scale ) + '%';
  _Preview.OnChangeScale := OnChangeScale;
  _Preview.OnChangePage := OnChangePage;
  _Paper.OnDrawObject := DrawItems;
  OnChangeScale( Nil );
  BackUpPage := edPageNum.Text;
  Edit1.SetFocus;
end;

procedure TfmPreview.sbCloseClick(Sender: TObject);
begin
  Close;
end;

procedure TfmPreview.sbZoomInClick(Sender: TObject);
begin
  With _Preview Do
    Begin
      ZoomIn;
    End;
end;

procedure TfmPreview.sbZoomOutClick(Sender: TObject);
begin
  With _Preview Do
    Begin
      ZoomOut;
    End;
end;

procedure TfmPreview.cbScaleKeyPress(Sender: TObject; var Key: Char);
Var
  S : String;
  I : Integer;
begin
  Case Key Of
  #13 : Begin
          Key := #0;
          S := cbScale.Text;
          Delete( S, Pos('%', S), 1 );
          Try
            I := StrToInt( S );
          Except
            cbScale.Text := BackUpScale;
            Edit1.SetFocus;
            Exit;
          End;
          With _Preview Do
            Begin
              If (I >= MinScale) And (I <= MaxScale )
                Then Scale := I
                Else If I > MaxScale
                       Then Scale := MaxScale
                       Else Scale := MinScale;
            End;
          Edit1.SetFocus;
        End;
  #27 : Begin
          cbScale.Text := BackUpScale;
          Edit1.SetFocus;
        End;
  #8  :;
  Else Begin
         If Not (Key In ['0'..'9', '%'])
           Then Key := #0;
       End;
  End;{ case }
end;

procedure TfmPreview.edPageNumEnter(Sender: TObject);
begin
  BackUpPage := edPageNum.Text;
end;

procedure TfmPreview.edPageNumKeyPress(Sender: TObject; var Key: Char);
Var
  S : String;
  I : Integer;
begin
  Case Key Of
  #13 : Begin
          Key := #0;        
          S := edPageNum.Text;
          Try
            I := StrToInt( S );
          Except
            edPageNum.Text := BackUpPage;
            Edit1.SetFocus;
            Exit;
          End;
          If (I > udPage.Min) And (I <= udPage.Max )
            Then Begin
                   _Preview.CurrentPage := I;
                   BackUpPage := cbScale.Text;
                 End
            Else Begin
                   edPageNum.Text := BackUpPage;
                 End;
          Edit1.SetFocus;
        End;
  #27 : Begin
          edPageNum.Text := BackUpPage;
          Edit1.SetFocus;
        End;
  #8  :;
  Else Begin
         If Not (Key In ['0'..'9'])
           Then Key := #0;
       End;
  End;{ case }
end;

procedure TfmPreview.udPageChangingEx(Sender: TObject;
  var AllowChange: Boolean; NewValue: Smallint;
  Direction: TUpDownDirection);
begin
  With _Preview Do
    Begin
      If (NewValue <= MaxPage) And (NewValue >= MinPage)
        Then Begin
               AllowChange := True;
               CurrentPage := NewValue;
             End
        Else Begin
               AllowChange := False;
             End;
    End;
end;

procedure TfmPreview.sbFirstClick(Sender: TObject);
begin
  With _Preview Do
    Begin
      CurrentPage := MinPage;
      udPage.Position := CurrentPage;
    End;
end;

procedure TfmPreview.sbPrevClick(Sender: TObject);
begin
  With _Preview Do
    Begin
      If CurrentPage > MinPage
        Then CurrentPage := CurrentPage - 1;
      udPage.Position := CurrentPage;
    End;
end;

procedure TfmPreview.sbNextClick(Sender: TObject);
begin
  With _Preview Do
    Begin
      If CurrentPage < MaxPage
        Then CurrentPage := CurrentPage + 1;
      udPage.Position := CurrentPage;
    End;
end;

procedure TfmPreview.sbLastClick(Sender: TObject);
begin
  With _Preview Do
    Begin
      CurrentPage := MaxPage;
      udPage.Position := CurrentPage;
    End;
end;

procedure TfmPreview.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
Var
  ScrollPos : Integer;
begin
  If Not Edit1.Focused
    Then Exit;
  If Not CanKeyPress
    Then Begin
           Exit;
         End;
  Case Key Of
  VK_UP    : Begin
               If ScrollBarVert.Enabled
                 Then Begin
                        If ssCtrl In Shift
                          Then Begin
                                 If (ScrollBarVert.Position > ScrollBarVert.Min) And (ScrollBarVert.Enabled)
                                   Then ScrollBarVert.Position := ScrollBarVert.Position - (ScrollBarVert.Max Div 5)
                                   Else Exit;
                                 OnVertScroll( ScrollBarVert, scTrack, ScrollPos );
                               End
                          Else Begin
                                 If ssShift In Shift
                                   Then Begin
                                          If (ScrollBarVert.Position > ScrollBarVert.Min) And (ScrollBarVert.Enabled)
                                            Then ScrollBarVert.Position := ScrollBarVert.Position - ScrollBarVert.SmallChange
                                            Else Exit;
                                          OnVertScroll( ScrollBarVert, scTrack, ScrollPos );
                                        End
                                   Else Begin
                                          If (ScrollBarVert.Position > ScrollBarVert.Min) And (ScrollBarVert.Enabled)
                                            Then ScrollBarVert.Position := ScrollBarVert.Position - (ScrollBarVert.Max Div SmallChange_Range)
                                            Else Exit;
                                          OnVertScroll( ScrollBarVert, scTrack, ScrollPos );
                                        End;
                               End;
                      End;
             End;
  VK_DOWN  : Begin
               If ScrollBarVert.Enabled
                 Then Begin
                        If ssCtrl In Shift
                          Then Begin
                                 If (ScrollBarVert.Position < ScrollBarVert.Max - ScrollBarVert.PageSize) And (ScrollBarVert.Enabled)
                                   Then Begin
                                          ScrollBarVert.Position := ScrollBarVert.Position + (ScrollBarVert.Max Div LargeChange_Range);
                                          If ScrollBarVert.Position > ScrollBarVert.Max - ScrollBarVert.PageSize
                                            Then ScrollBarVert.Position := ScrollBarVert.Max - ScrollBarVert.PageSize + 1;
                                        End
                                   Else Exit;
                                 OnVertScroll( ScrollBarVert, scTrack, ScrollPos );
                               End
                          Else Begin
                                 If ssShift In Shift
                                   Then Begin
                                          If (ScrollBarVert.Position <= ScrollBarVert.Max - ScrollBarVert.PageSize) And (ScrollBarVert.Enabled)
                                            Then Begin
                                                   ScrollBarVert.Position := ScrollBarVert.Position + ScrollBarVert.SmallChange;
                                                   If ScrollBarVert.Position > ScrollBarVert.Max - ScrollBarVert.PageSize
                                                     Then ScrollBarVert.Position := ScrollBarVert.Max - ScrollBarVert.PageSize + 1;
                                                 End
                                            Else Exit;
                                          OnVertScroll( ScrollBarVert, scTrack, ScrollPos );
                                        End
                                   Else Begin
                                          If (ScrollBarVert.Position <= ScrollBarVert.Max - ScrollBarVert.PageSize) And (ScrollBarVert.Enabled)
                                            Then Begin
                                                   ScrollBarVert.Position := ScrollBarVert.Position + (ScrollBarVert.Max Div SmallChange_Range);
                                                   If ScrollBarVert.Position > ScrollBarVert.Max - ScrollBarVert.PageSize
                                                     Then ScrollBarVert.Position := ScrollBarVert.Max - ScrollBarVert.PageSize + 1;
                                                 End
                                            Else Exit;
                                          OnVertScroll( ScrollBarVert, scTrack, ScrollPos );
                                        End;
                               End;
                      End;
             End;
  VK_LEFT  : Begin
               If ScrollBarHorz.Enabled
                 Then Begin
                        If ssCtrl In Shift
                          Then Begin
                                 If (ScrollBarHorz.Position > 0) And (ScrollBarHorz.Enabled)
                                   Then ScrollBarHorz.Position := ScrollBarHorz.Position - (ScrollBarHorz.Max Div 5)
                                   Else Exit;
                                 OnHorzScroll( ScrollBarVert, scTrack, ScrollPos );
                               End
                          Else Begin
                                 If ssShift In Shift
                                   Then Begin
                                          If (ScrollBarHorz.Position > 0) And (ScrollBarHorz.Enabled)
                                            Then ScrollBarHorz.Position := ScrollBarHorz.Position - ScrollBarHorz.SmallChange
                                            Else Exit;
                                          OnHorzScroll( ScrollBarVert, scTrack, ScrollPos );
                                        End
                                   Else Begin
                                          If (ScrollBarHorz.Position > 0) And (ScrollBarHorz.Enabled)
                                            Then ScrollBarHorz.Position := ScrollBarHorz.Position - (ScrollBarHorz.Max Div SmallChange_Range)
                                            Else Exit;
                                          OnHorzScroll( ScrollBarVert, scTrack, ScrollPos );
                                        End;
                               End;
                      End;
             End;
  VK_RIGHT : Begin
               If ScrollBarHorz.Enabled
                 Then Begin
                        If ssCtrl In Shift
                          Then Begin
                                 If (ScrollBarHorz.Position < ScrollBarHorz.Max - ScrollBarHorz.PageSize) And (ScrollBarHorz.Enabled)
                                   Then Begin
                                          ScrollBarHorz.Position := ScrollBarHorz.Position + (ScrollBarHorz.Max Div 5);
                                          If ScrollBarHorz.Position > ScrollBarHorz.Max - ScrollBarHorz.PageSize
                                            Then ScrollBarHorz.Position := ScrollBarHorz.Max - ScrollBarHorz.PageSize + 1;
                                        End
                                   Else Exit;
                                 OnHorzScroll( ScrollBarVert, scTrack, ScrollPos );
                               End
                          Else Begin
                                 If ssShift In Shift
                                   Then Begin
                                          If ( ScrollBarHorz.Position <= ScrollBarHorz.Max - ScrollBarHorz.PageSize ) And (ScrollBarHorz.Enabled)
                                            Then Begin
                                                   ScrollBarHorz.Position := ScrollBarHorz.Position + ScrollBarHorz.SmallChange;
                                                   If ScrollBarHorz.Position > ScrollBarHorz.Max - ScrollBarHorz.PageSize
                                                     Then ScrollBarHorz.Position := ScrollBarHorz.Max - ScrollBarHorz.PageSize + 1;
                                                 End
                                            Else Exit;
                                          OnHorzScroll( ScrollBarVert, scTrack, ScrollPos );
                                        End
                                   Else Begin
                                          If ( ScrollBarHorz.Position <= ScrollBarHorz.Max - ScrollBarHorz.PageSize ) And (ScrollBarHorz.Enabled)
                                            Then Begin
                                                   ScrollBarHorz.Position := ScrollBarHorz.Position + (ScrollBarHorz.Max Div SmallChange_Range);
                                                   If ScrollBarHorz.Position > ScrollBarHorz.Max - ScrollBarHorz.PageSize
                                                     Then ScrollBarHorz.Position := ScrollBarHorz.Max - ScrollBarHorz.PageSize + 1;
                                                 End
                                            Else Exit;
                                          OnHorzScroll( ScrollBarVert, scTrack, ScrollPos );
                                        End;
                               End;
                      End;
             End;
  VK_PRIOR : If Edit1.Focused
               Then sbPrevClick( Sender );
  VK_NEXT  : If Edit1.Focused
               Then sbNextClick( Sender );
  VK_HOME  : If Edit1.Focused
               Then sbFirstClick( Sender );
  VK_END   : If Edit1.Focused
               Then sbLastClick( Sender );
{"+"}  107 : Begin
               If Edit1.Focused
                 Then sbZoomInClick( Sender );
             End;
{"-"}  109 : If Edit1.Focused
               Then sbZoomOutClick( Sender );
 VK_ESCAPE : Close;
{ F2 }
    VK_F2 : Begin
              sb_SaveClick( sb_Save );
            End;
{ F3 }
     VK_F3: Begin
               sb_OpenClick( sb_Open );
            End;
{ F9 }
    VK_F9 : Begin
              sb_PrintClick( sb_Print );
            End;
{ F4 }
    VK_F4 : Begin
              sb_PageSetupClick( sb_PageSetup );
            End;
{ F10 }
   VK_F10 : Begin
              sb_AboutClick( sb_About );
            End;
{ F1 }
    VK_F1 : Begin
               sb_HelpClick( sb_Help );
            End;

  Else Exit;
  End;{ case }
end;

procedure TfmPreview.FormKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
Var
  ScrollPos : Integer;
begin
  If Not Edit1.Focused
    Then Exit;
  CanKeyPress := True;
  Case Key Of
  VK_UP    : Begin
               If ScrollBarVert.Enabled
                 Then Begin
                        OnVertScroll( ScrollBarVert, scLineUp, ScrollPos );
                      End;
             End;
  VK_DOWN  : Begin
               If ScrollBarVert.Enabled
                 Then Begin
                        OnVertScroll( ScrollBarVert, scLineUp, ScrollPos );
                      End;
             End;
  VK_LEFT  : Begin
               If ScrollBarHorz.Enabled
                 Then Begin
                        OnVertScroll( ScrollBarVert, scLineUp, ScrollPos );
                      End;
             End;
  VK_RIGHT : Begin
               If ScrollBarHorz.Enabled
                 Then Begin
                        OnVertScroll( ScrollBarVert, scLineUp, ScrollPos );
                      End;
             End;
  End;{ case }
end;

procedure TfmPreview.FormDestroy(Sender: TObject);
begin
  fmScalesList.Free;
  ScrollBarVert.Free;
  ScrollBarHorz.Free;
  ResultImage.Free;
  DrawProgress.Free;
end;

procedure TfmPreview.FormPaint(Sender: TObject);
begin
  Canvas.Draw( PaperDX, PaperDY, ResultImage );
end;

procedure TfmPreview.btDropDownClick(Sender: TObject);
Var
  S : String;
begin
  With ( _Preview As TPreview ) Do
    Begin
      S := IntToStr( Scale ) + '%';
      fmScalesList.ListBox1.ItemIndex := fmScalesList.ListBox1.Items.IndexOf( S );
      fmScalesList.Show;
    End;
end;

procedure TfmPreview.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  FirstTime := True;
  ResultImage.Width := 10;
  ResultImage.Height := 10;
end;

procedure TfmPreview.sbLanguageClick(Sender: TObject);
begin
  menuLanguage.Popup( 302, Height - StatusBar1.Height - 40 );
end;

procedure TfmPreview.menuEnglishClick(Sender: TObject);
begin
  If Sender = menuEnglish
    Then _Preview.Language := English;
  If Sender = menuRussian
    Then _Preview.Language := Russian;
  (Sender As TMenuItem).Checked := True;
  SetLanguage;
end;

procedure TfmPreview.sb_PrintClick(Sender: TObject);
Var
  I : Integer;
begin
  If Not PrintDialog1.Execute
    Then Exit;
  With _Preview Do
    Begin
      If PrintDialog1.PrintToFile
        Then Begin
               If PrintDialog1.PrintRange = prAllPages
                 Then Begin
                        If SaveDialog1.Execute
                          Then Begin
                                 If FileExists(SaveDialog1.FileName)
                                   Then Begin
                                          Case Application.MessageBox( PChar(WriteQuestion[Lang]), PChar(WriteTitle[Lang]), MB_YESNOCANCEL Or MB_ICONQUESTION ) Of
                                          idYes : _Paper.SaveToFile(SaveDialog1.FileName, PAGE_NEW );
                                          idNo  : _Paper.SaveToFile(SaveDialog1.FileName, PAGE_ADD );
                                          Else Exit;
                                          End;{ Case }
                                        End
                                   Else Begin
                                          _Paper.SaveToFile(SaveDialog1.FileName, PAGE_NEW );
                                        End;
                                 OnChangeScale( Nil );
                               End;
                      End
                 Else Begin
                        If SaveDialog1.Execute
                          Then Begin
                                 If FileExists(SaveDialog1.FileName)
                                   Then Begin
                                          Case Application.MessageBox( PChar(WriteQuestion[Lang]), PChar(WriteTitle[Lang]), MB_YESNOCANCEL Or MB_ICONQUESTION ) Of
                                          idYes : Begin
                                                    _Paper.SavePageToFile( SaveDialog1.FileName, PrintDialog1.FromPage, PAGE_NEW );
                                                    For I := PrintDialog1.FromPage+1 To PrintDialog1.ToPage Do
                                                      _Paper.SavePageToFile( SaveDialog1.FileName, I, PAGE_ADD );
                                                  End;
                                          idNo  : Begin
                                                    For I := PrintDialog1.FromPage To PrintDialog1.ToPage Do
                                                      _Paper.SavePageToFile( SaveDialog1.FileName, I, PAGE_ADD );
                                                   End;
                                          Else Exit;
                                          End;{ Case }
                                        End
                                   Else Begin
                                          For I := PrintDialog1.FromPage To PrintDialog1.ToPage Do
                                            _Paper.SavePageToFile( SaveDialog1.FileName, I, PAGE_ADD );
                                        End;
                                 OnChangeScale( Nil );
                               End;
                      End;
             End
        Else Begin
               If PrintDialog1.PrintRange = prAllPages
                 Then Begin
                        For I := 1 To PrintDialog1.Copies Do
                          Print;
                      End
                 Else Begin
                        For I := 1 To PrintDialog1.Copies Do
                          PrintPages( PrintDialog1.FromPage, PrintDialog1.ToPage );
                      End;
             End;
    End;
end;

procedure TfmPreview.sb_OpenClick(Sender: TObject);
begin
  If OpenDialog1.Execute
    Then Begin
           Case Application.MessageBox( PChar(ReadQuestion[Lang]), PChar(ReadTitle[Lang]), MB_YESNOCANCEL Or MB_ICONQUESTION ) Of
           idYes : _Paper.LoadFromFile(OpenDialog1.FileName, PAGE_NEW );
           idNo  : _Paper.LoadFromFile(OpenDialog1.FileName, PAGE_ADD );
           Else Exit;
           End;{ Case }
           OnChangeScale( Nil );
         End;
end;

procedure TfmPreview.sb_SaveClick(Sender: TObject);
begin
  If SaveDialog1.Execute
    Then Begin
           If FileExists(SaveDialog1.FileName)
             Then Begin
                    Case Application.MessageBox( PChar(WriteQuestion[Lang]), PChar(WriteTitle[Lang]), MB_YESNOCANCEL Or MB_ICONQUESTION ) Of
                    idYes : _Paper.SaveToFile(SaveDialog1.FileName, PAGE_NEW );
                    idNo  : _Paper.SaveToFile(SaveDialog1.FileName, PAGE_ADD );
                    Else Exit;
                    End;{ Case }
                  End
             Else Begin
                    _Paper.SaveToFile(SaveDialog1.FileName, PAGE_NEW );
                  End;
         End;
end;

procedure TfmPreview.OpenDialog1Show(Sender: TObject);
begin
  OpenDialog1.FileName := DefaultFileName;
end;

procedure TfmPreview.sb_HelpClick(Sender: TObject);
Var
  Topic : PChar;
begin
  Case Lang Of
  English : Try
              Topic := 'mk:@MSITStore:PreviewForm.chm::/en/PreviewFormHelp.htm';
              HtmlHelpA( Screen.ActiveForm.handle, Topic, 0, 0 );
            Except
            End;
  Russian : Try
              Topic := 'mk:@MSITStore:PreviewForm.chm::/ru/PreviewFormHelp.htm';
              HtmlHelpA( Screen.ActiveForm.handle, Topic, 0, 0 );
            Except
            End;
  End;{ case }
end;

procedure TfmPreview.FormMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
Var
  DeltaX  : Integer;
  DeltaY  : Integer;
begin
  If (( PaperDX <= X ) And (X <= PaperDX + ResultImage.Width)) And
     (( PaperDY <= Y ) And (Y <= PaperDY + ResultImage.Height)) And
     ( ScrollBarVert.Enabled Or ScrollBarHorz.Enabled )
    Then Begin
           CanDragging := True;
           Cursor := CursorDrag;
           If Dragging
             Then Begin
                    DeltaX := (DragX - X);
                    DeltaY := (DragY - Y);
                    DeltaX := PosX + DeltaX;
                    DeltaY := PosY + DeltaY;
                    
                    If DeltaX > ScrollBarHorz.Max - ScrollBarHorz.PageSize
                      Then DeltaX := ScrollBarHorz.Max - ScrollBarHorz.PageSize;
                    If DeltaX < ScrollBarHorz.Min
                      Then DeltaX := ScrollBarHorz.Min;
                    If ScrollBarHorz.Enabled
                      Then Begin
                             ScrollBarHorz.Position := DeltaX;
                             OnHorzScroll( Nil, scLineUp, DeltaX );
                           End;

                    If DeltaY > ScrollBarVert.Max - ScrollBarVert.PageSize
                      Then DeltaY := ScrollBarVert.Max - ScrollBarVert.PageSize;
                    If DeltaY < ScrollBarVert.Min
                      Then DeltaY := ScrollBarVert.Min;
                    If ScrollBarVert.Enabled
                      Then Begin
                             ScrollBarVert.Position := DeltaY;
                             OnVertScroll( Nil, scLineUp, DeltaY );
                           End;
                  End;
         End
    Else Begin
           Dragging := False;
           Cursor := crDefault;
         End;
end;

procedure TfmPreview.FormMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  If CanDragging
    Then Begin
           Dragging := True;
           DragX := X;
           DragY := Y;
           PosX := ScrollBarHorz.Position;
           PosY := ScrollBarVert.Position;
         End;
end;

procedure TfmPreview.FormMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  Dragging := False;
end;

procedure TfmPreview.menu200Click(Sender: TObject);
begin
  (Sender As TMenuItem).Checked := True;
  If Sender = menu200
    Then _Preview.Scale := 200; 
  If Sender = menu150
    Then _Preview.Scale := 150;
  If Sender = menu100
    Then _Preview.Scale := 100;
  If Sender = menu75
    Then _Preview.Scale := 75;
  If Sender = menu50
    Then _Preview.Scale := 50;
  If Sender = menu25
    Then _Preview.Scale := 25;
  If Sender = menuFitWidth
    Then _Preview.FitPage( fitPageWidth );
  If Sender = menuFitHeight
    Then _Preview.FitPage( fitPageHeight );
  If Sender = menuWholePage
    Then _Preview.FitPage( fitWholePage );
end;

procedure TfmPreview.sb_PageSetupClick(Sender: TObject);
begin
  fmPrinterOptions := TfmPrinterOptions.Create( Self );
  fmPrinterOptions.Caption := 'Page setup'; 
  fmPrinterOptions.CurrPrinter.Orientation := _Paper.PrinterSetup.Orientation;
  fmPrinterOptions.CurrPrinter.PaperWidth_MM := _Paper.PrinterSetup.PaperWidth_MM;
  fmPrinterOptions.CurrPrinter.PaperHeight_MM := _Paper.PrinterSetup.PaperHeight_MM;
  fmPrinterOptions.CurrPrinter.PaperFormat := _Paper.PrinterSetup.PaperFormat;
  fmPrinterOptions.SetPaperFormat( fmPrinterOptions.CurrPrinter.PaperFormat );
  fmPrinterOptions.SetOrientation( fmPrinterOptions.CurrPrinter.Orientation );
  fmPrinterOptions.SetWidth_MM( fmPrinterOptions.CurrPrinter.PaperWidth_MM );
  fmPrinterOptions.SetHeight_MM( fmPrinterOptions.CurrPrinter.PaperHeight_MM );
  If fmPrinterOptions.ShowModal = 1 //OK
    Then Begin
           _Paper.PrinterSetup.PaperFormat := fmPrinterOptions.CurrPrinter.PaperFormat;
           _Paper.PrinterSetup.Orientation := fmPrinterOptions.CurrPrinter.Orientation;
           _Paper.PrinterSetup.PaperWidth_MM := fmPrinterOptions.CurrPrinter.PaperWidth_MM;
           _Paper.PrinterSetup.PaperHeight_MM := fmPrinterOptions.CurrPrinter.PaperHeight_MM;
           OnChangeScale( Nil );
         End;
  fmPrinterOptions.Free;
end;

procedure TfmPreview.sb_AboutClick(Sender: TObject);
Var
  Topic : PChar;
begin
  Case Lang Of
  English : Try
              Topic := 'mk:@MSITStore:PreviewForm.chm::/en/About.htm';
              HtmlHelpA( Screen.ActiveForm.handle, Topic, 0, 0 );
            Except
            End;
  Russian : Try
              Topic := 'mk:@MSITStore:PreviewForm.chm::/ru/About.htm';
              HtmlHelpA( Screen.ActiveForm.handle, Topic, 0, 0 );
            Except
            End;
  End;{ case }
end;

end.

