unit ScalesList;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;

type
  TfmScalesList = class(TForm)
    ListBox1: TListBox;
    Bevel1: TBevel;
    procedure FormDeactivate(Sender: TObject);
    procedure ListBox1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure ListBox1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormActivate(Sender: TObject);
    procedure ListBox1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
  private
    { Private declarations }
    Clicked : Boolean;
  public
    { Public declarations }
  end;

var
  fmScalesList : TfmScalesList;

implementation
Uses Preview, PreviewForm;

{$R *.DFM}

procedure TfmScalesList.FormDeactivate(Sender: TObject);
begin
  Close;
end;

procedure TfmScalesList.ListBox1MouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
Var
  N : Integer;
begin
  N := Y Div ListBox1.ItemHeight;
  ListBox1.ItemIndex := N;
end;

procedure TfmScalesList.ListBox1MouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  If Clicked
    Then Begin
           With (fmPreview.Owner As TPreview) Do
             Begin
               Case fmScalesList.ListBox1.ItemIndex Of
               0 : Begin
                     Scale := 200;
                     fmPreview.menu200.Checked := True;
                   End;
               1 : Begin
                     Scale := 150;
                     fmPreview.menu150.Checked := True;
                   End;
               2 : Begin
                     Scale := 100;
                     fmPreview.menu100.Checked := True;
                   End;
               3 : Begin
                     Scale := 75;
                     fmPreview.menu75.Checked := True;
                   End;
               4 : Begin
                     Scale := 50;
                     fmPreview.menu50.Checked := True;
                   End;
               5 : Begin
                     Scale := 25;
                     fmPreview.menu25.Checked := True;
                   End;
               6 : Begin
                     FitPage( fitPageWidth );
                     fmPreview.menuFitWidth.Checked := True;
                   End;
               7 : Begin
                     FitPage( fitPageHeight );
                     fmPreview.menuFitHeight.Checked := True;
                   End;
               8 : Begin
                     FitPage( fitWholePage );
                     fmPreview.menuWholePage.Checked := True;
                   End;
                End;{ Case }
             End;
           Close;
         End;
end;

procedure TfmScalesList.FormActivate(Sender: TObject);
begin
  Clicked := False;
end;

procedure TfmScalesList.ListBox1MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  Clicked := True;
end;

procedure TfmScalesList.FormKeyPress(Sender: TObject; var Key: Char);
begin
  Case Key Of
   #13 : Begin
           With (fmPreview.Owner As TPreview) Do
             Begin
               Case fmScalesList.ListBox1.ItemIndex Of
               0 : Begin
                     Scale := 200;
                     fmPreview.menu200.Checked := True;
                   End;
               1 : Begin
                     Scale := 150;
                     fmPreview.menu150.Checked := True;
                   End;
               2 : Begin
                     Scale := 100;
                     fmPreview.menu100.Checked := True;
                   End;
               3 : Begin
                     Scale := 75;
                     fmPreview.menu75.Checked := True;
                   End;
               4 : Begin
                     Scale := 50;
                     fmPreview.menu50.Checked := True;
                   End;
               5 : Begin
                     Scale := 25;
                     fmPreview.menu25.Checked := True;
                   End;
               6 : Begin
                     FitPage( fitPageWidth );
                     fmPreview.menuFitWidth.Checked := True;
                   End;
               7 : Begin
                     FitPage( fitPageHeight );
                     fmPreview.menuFitHeight.Checked := True;
                   End;
               8 : Begin
                     FitPage( fitWholePage );
                     fmPreview.menuWholePage.Checked := True;
                   End;
               End;{ case }
             End;
           Close;
         End;
   #27 : Begin
           Close;
         End;
     End;{Case }
end;

end.
